---
layout: layouts/test.njk
class: 4AHEL
group: A
subject: FSST
date: 2022-06-14
points: [18, 6]
grading: "Benotung: >=21: 1, >=18: 2, >=15: 3, >=12: 4, <12: 5"
---

<p>Die Verwendung von Unterlagen ist erlaubt. Die Abgabe erfolgt auf
  Eduvidual.
</p>

<p>Lade die
<a href="https://www.senarclens.eu/~gerald/teaching/Northwind_large.sqlite.bz2">Northwind Datenbank</a>
herunter und entpacke sie. Lade ebenfalls das gegebene Qt Projekt
von Eduvidual herunter und öffne dieses.
</p>

<ol>
  <li><strong>Qt</strong><br />
    Bei diesem Beispiel ist ein Archiv des gesamten Programmcodes abzugeben.
    Punkte werden nur vergeben, wenn das Projekt ohne Änderungen kompilierbar
    und lauffähig ist. Jede Teilaufgabe ist 3 Punkte wert.
    Das Projekt in seiner aktuellen Form verwendet
    <code>QSqlQueryModel</code> um das Resultat einer SQL Abfrage im
    vorhandenen <code>QTableView</code> darzustellen.
    Passe den Pfad zur Datenbank an, damit diese erfolgreich geöffnet wird.
    Setze folgende
    Verbesserungen am Projekt um:

    <ol>
      <li>Benutzer sollen den Query verändern können. Füge dem Projekt
        ein <code>QPlainTextEdit</code> (Textfeld) und einen
        <code>QPushButton</code> hinzu.
      </li>
      <li>Das Layout soll so angepasst werden, dass die beiden neuen
        Steuerelemente gemeinsam in einer Zeile unterhalb des vorhandenen
        <code>QTableView</code> dargestellt werden. Beim Vergrößern und
        Verkleinern des Fensters soll die größe der Steuerelemente
        automatisch angepasst werden (<code>QTableView</code> und
        <code>QPlainTextEdit</code> sollen mit dem Fenster wachsen und
        schrumpfen</li>
      <li>Benenne die Steuerelemente wie folgt um:
        <code>QPlainTextEdit</code> soll den <code>objectName</code>
        "<kbd>firstname_query</kbd>" bekommen, wobei <kbd>firstname</kbd>
        durch den eigenen Vornamen zu ersetzen ist. Analog soll der
        <code>QPushButton</code> auf "<kbd>firstname_button</kbd>"
        umbenannt werden.
      </li>
      <li>Stelle die Schriftart (<kbd>font</kbd>) des
        <code>QPlainTextEdit</code> auf <kbd>monospace</kbd> um.
      </li>
      <li>Im neuen <code>QPlainTextEdit</code> sollen
        mehrzeilige Abfragen geschrieben werden können. Ein Clicken auf
        den <code>QPushButton</code> soll die jeweilige Abfrage ausführen
        und das Ergebnis im <code>QTableView</code> darstellen.</li>
      <li>Der Konstruktor des <code>MainWindow</code> und der
        click Handler des <code>QPushButton</code> führen weitgehend
        identischen Code aus. Verbessere den Code so, dass diese
        Duplikation durch Verwendung einer zusätzlichen Funktion
        vermieden wird.</li>
    </ol>
  </li>

  <li><strong>Datenbanken</strong><br />
    Schreibe die folgenden beiden Datenbankabfragen in dem soeben erstellten
    Qt Interface unter korrekter Verwendung von <code>JOIN</code>.<br />
    Abzugeben sind eine Textdatei mit dem Text der Queries und jeweils ein
    Screenshot des erfolgreichen Queries und dessen Ergebnisses im selbst
    programmierten Qt Datenbankclient.
    <ol>
      <li>Liste alle Produkte der Kategorien mit den Namen
        'Dairy Products' und 'Produce'.
{% answer %}
{% highlight "sql" %}
select * from products
natural join categories
where CategoryName in ('Dairy Products', 'Produce');
{% endhighlight %}
{% endanswer %}
      </li>
      <li>Liste die Namen und Telefonnummer aller Anbieter, von denen eine
        Nachbestellung dringend notwendig ist. Liste auch die Produktnummer,
        welche nachbestellt werden muss. Dringend nachbestellt werden müssen
        alle Produkte, bei denen die Summe aus Lagerstand und aktueller
        Nachbestellung kleiner als der <code>ReorderLevel</code> ist.
{% answer %}
{% highlight "sql" %}
select ContactName, Phone, ProductId from products
natural join suppliers
where UnitsInStock + UnitsOnOrder < ReorderLevel;
{% endhighlight %}
{% endanswer %}
      </li>
    </ol>

  </li>

</ol>
